﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace midi
{
    public class FormatConverter
    {
        public static int[] BeepToMidi(string beep)
        {
            var result = new List<int>();
            var b = beep.Split(" \t\r\n".ToCharArray(), StringSplitOptions.RemoveEmptyEntries);
            for (int i = 0; i < b.Length; i += 2)
            {
                if (b[i] == "0")
                {
                    result.Add(-1);
                }
                else
                {
                    result.Add(NoteNumberFromFriquency(double.Parse(b[i])));
                }
                result.Add(int.Parse(b[i + 1]));
            }
            return result.ToArray();
        }

        public static int[] BeepToMidiMessages(string beep)
        {
            var result = new List<int>();
            var b = beep.Split(" \t\r\n".ToCharArray(), StringSplitOptions.RemoveEmptyEntries);
            for (int i = 0; i < b.Length; i += 2)
            {
                var duration = int.Parse(b[i + 1]);
                if (b[i] == "0")
                {
                    result.Add(0);
                    result.Add(duration);
                }
                else
                {
                    var note = NoteNumberFromFriquency(double.Parse(b[i]));
                    var msg = 127 << 16 | note << 8 | 0x90;
                    result.Add(msg);
                    result.Add(0);
                    result.Add(duration);
                    result.Add(note << 8 | 0x80);

                }
            }
            return result.ToArray();
        }

        public static int NoteNumberFromFriquency(double friquency)
        {
            return (int)Math.Round(69.0 + 12.0 * (Math.Log(friquency / 440.0) / Math.Log(2.0)));
        }

    }
}
