﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace midi
{
    public partial class MainForm : Form
    {
        public MainForm()
        {
            InitializeComponent();
        }

        private void MainForm_Load(object sender, EventArgs e)
        {
            var forms = Assembly.GetExecutingAssembly().GetTypes().Where(t => typeof(Form).IsAssignableFrom(t) && t != this.GetType()).ToList();
            listBox1.DataSource = forms.Select(f =>
              new
              {
                  Name = ((DisplayNameAttribute)f.GetCustomAttribute(typeof(DisplayNameAttribute))).DisplayName,
                  Description = ((DescriptionAttribute)f.GetCustomAttribute(typeof(DescriptionAttribute))).Description,
                  Type = f
              }

            ).ToList();
        }

        private void listBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            dynamic item = listBox1.SelectedItem;
            label1.Text = item.Description;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            dynamic item = listBox1.SelectedItem;
            (Activator.CreateInstance(item.Type) as Form).Show();
        }
    }
}
