﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace midi
{
    public static class Melodies
    {
        public static void PlayImperialWithMessages()
        {
            var player = new MelodyPlayer();
            player.MsgList = FormatConverter.BeepToMidiMessages(Properties.Resources.ImperialBeep);
            player.Open();
            player.Play();
            player.Close();
        }

        public static void PlayImperialWithNotes()
        {
            var songInt = FormatConverter.BeepToMidi(Properties.Resources.ImperialBeep);
            var player = new MelodyPlayer();
            player.Open();
            player.SetInstrument(44);
            for (int i = 0; i < songInt.Length; i += 2)
            {
                if (songInt[i] == -1)
                {
                    Thread.Sleep(songInt[i + 1]);
                }
                else
                {
                    player.PlayNote(songInt[i], songInt[i + 1]);
                }
            }
            player.Close();
        }

        public static void PlayElCondorPasaWithNotes()
        {
            var parser = new MusicFileParser();
            var song = parser.Parse(Properties.Resources.ElCondorPasa);
            var songInt = FormatConverter.BeepToMidi(song);
            var player = new MelodyPlayer();
            player.Open();
            player.SetInstrument(MusicalInstruments.Shakuhachi);
            for (int i = 0; i < songInt.Length; i += 2)
            {
                if (songInt[i] == -1)
                {
                    Thread.Sleep(songInt[i + 1]);
                }
                else
                {
                    player.PlayNote(songInt[i], songInt[i + 1]);
                }
            }
            player.Close();
        }

        public static void PlayElCondorPasaWithMessages()
        {
            var player = new MelodyPlayer();
            var parser = new MusicFileParser();
            player.MsgList = new int[] { 78 << 8 | 0xC0 }.Concat(  FormatConverter.BeepToMidiMessages(parser.Parse(Properties.Resources.ElCondorPasa))).ToArray();
            player.Open();
            player.Play();
            player.Close();
        }

    }
}
