﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace midi
{
    [DisplayName("Примеры мелодий"), Description("В данной форме есть возможность проиграть мелодии и аккорды, " +
        "преимущественно из первых двух частей статьи. Мелодия, проигрываемая с помощью таймера тоже находится здесь.")]
    public partial class FormMelodies : Form
    {


        public FormMelodies()
        {
            InitializeComponent();
        }


        private void button1_Click(object sender, EventArgs e)
        {
            Melodies.PlayElCondorPasaWithMessages();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            var player = new MelodyPlayer();
            Melodies.PlayImperialWithNotes();
            Melodies.PlayImperialWithMessages();
        }

        private void button3_Click(object sender, EventArgs e)
        {
            var player = new MelodyPlayer();
            var list = Properties.Resources.ElCondorPasaChords.Split(" \r\n\t".ToCharArray(), StringSplitOptions.RemoveEmptyEntries).SelectMany(ChordMaster.GetChord);
            player.MsgList = new int[] { 25 << 8 | 0xC1, 0, 3000 / 4 }.Concat(list).ToArray();
            player.Open();
            player.Play();
            player.Close();
        }

        private void button4_Click(object sender, EventArgs e)
        {
            var parser = new MusicFileParser();

            var chords = Properties.Resources.ElCondorPasaChords.Split(" \r\n\t".ToCharArray(), StringSplitOptions.RemoveEmptyEntries).SelectMany(ChordMaster.GetChord).ToArray();
            chords = new int[] { 25 << 8 | 0xC1, 0, 3000 / 4 }.Concat(chords).ToArray();
            var melody = new int[] { 78 << 8 | 0xC0 }.Concat(FormatConverter.BeepToMidiMessages(parser.Parse(Properties.Resources.ElCondorPasa))).ToArray();
            var player = new MelodyPlayer();
            player.MsgList = MessageProcessor.MergeMessagesLists(chords, melody);
            player.Open();
            player.Play();
            player.Close();
        }

        private void button5_Click(object sender, EventArgs e)
        {
            var parser = new MusicFileParser();

            var chords = ChordMaster.ParseChords(@"5a.2 5a.2 5d.2 5d.2 5b-.1 5e.1 5a.2 5a.2", 3000, 127, 1);
            chords = new int[] { 25 << 8 | 0xC1, 0, 3000 / 4 }.Concat(chords).ToArray();
            var player = new MelodyPlayer();
            player.MsgList = chords;
            player.Open();
            player.Play();
            player.Close();
        }

        private void button6_Click(object sender, EventArgs e)
        {
            var parser = new MusicFileParser();

            var chords = ChordMaster.ParseChords(@"4a.4 4a.4 4d.4 4d.4 4b-.3 4e.3 4a.4 4a.4", 3000, 127, 1);
            chords = new int[] { 25 << 8 | 0xC1, 0, 3000 / 4 }.Concat(chords).ToArray();
            var player = new MelodyPlayer();
            player.MsgList = chords;
            player.Open();
            player.Play();
            player.Close();
        }

        private void button7_Click(object sender, EventArgs e)
        {
            var player = new TimerPlayer();
            var parser = new MusicFileParser();
            player.MsgList = new int[] { 78 << 8 | 0xC0 }.Concat(FormatConverter.BeepToMidiMessages(parser.Parse(Properties.Resources.ElCondorPasa))).ToArray();
            player.Open();
            player.Play();
        }
    }
}
