﻿using System.Runtime.InteropServices;
using System.Threading;

namespace midi
{
    class MelodyPlayer : PlayerBase
    {



        public void SetInstrument(int id)
        {
            midiOutShortMsg(handle, id << 8 | 0x000000C0);
        }

        public void PlayNote(int note, int duration)
        {
            midiOutShortMsg(handle, 127 << 16 | note << 8 | 0x00000090);
            Thread.Sleep(duration);
            midiOutShortMsg(handle, 127 << 16 | note << 8 | 0x00000080);
        }

        public void SetInstrument(MusicalInstruments id)
        {
            midiOutShortMsg(handle, (int)id << 8 | 0x000000C0);
        }

        public override void Play()
        {
            for (int i = 0; i < MsgList.Length; i++)
            {
                if (MsgList[i] == 0)
                {
                    i++;
                    Thread.Sleep(MsgList[i]);
                }
                else
                {
                    midiOutShortMsg(handle, MsgList[i]);

                };
            }
        }


    }
}
