﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace midi
{
    public static class MessageProcessor
    {
        public static int[] MergeMessagesLists(params int[][] lists)
        {
            var mplist = lists.SelectMany(GetPackagesList).OrderBy(mp => mp.TimeLine).ToArray();
            for (int i = 0; i < mplist.Count(); i++)
            {
                if (i > 0 && mplist[i].TimeLine == mplist[i - 1].TimeLine) continue;
                mplist[i].MessagesList.InsertRange(0, new int[] { 0, i == 0 ? mplist[i].TimeLine : mplist[i].TimeLine - mplist[i - 1].TimeLine });
            }
            return mplist.SelectMany(mp => mp.MessagesList).ToArray();
        }


        public static List<MessagesPackage> GetPackagesList(int[] msgs)
        {
            int timeline = 0;
            int counter = 0;
            List<MessagesPackage> result = new List<midi.MessagesPackage>();

            while (true)
            {
                if (msgs.Length <= counter) break;
                if (msgs[counter] == 0)
                {
                    counter++;
                    timeline += msgs[counter];
                    result.Add(new midi.MessagesPackage() { TimeLine = timeline });
                }
                else
                {
                    if (result.Count == 0) result.Add(new MessagesPackage() { TimeLine = 0 });
                    result.Last().MessagesList.Add(msgs[counter]);
                }
                counter++;
            }

            return result;
        }
    }
}
