﻿using MidiSample;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace midi
{
    class Music
    {

        [DllImport("winmm.dll")]
        private static extern long mciSendString(string command,
StringBuilder returnValue, int returnLength, IntPtr winHandle);

        [DllImport("winmm.dll")]
        private static extern int midiOutGetNumDevs();

        [DllImport("winmm.dll")]
        private static extern int midiOutGetDevCaps(Int32 uDeviceID,
           ref MidiOutCaps lpMidiOutCaps, UInt32 cbMidiOutCaps);

        [DllImport("winmm.dll")]
        private static extern int midiOutOpen(ref int handle,
           int deviceID, MidiCallBack proc, int instance, int flags);

        [DllImport("winmm.dll")]
        protected static extern int midiOutShortMsg(int handle,
           int message);

        [DllImport("winmm.dll")]
        protected static extern int midiOutClose(int handle);

        private delegate void MidiCallBack(int handle, int msg,
   int instance, int param1, int param2);

        public int GetDeviceNum()
        {
            return midiOutGetNumDevs();
        }

        public MidiOutCaps GetDevCaps(int deviceId)
        {
            MidiOutCaps myCaps = new MidiOutCaps();
            var res = midiOutGetDevCaps(deviceId, ref myCaps,
               (UInt32)Marshal.SizeOf(myCaps));
            return myCaps;
        }


        public void PlayC()
        {
            int handle = 0;

            var res = midiOutOpen(ref handle, 0, CallBack, 0, 0x00030000);
            //res = midiOutShortMsg(handle, 0x000019C0);
            res = midiOutShortMsg(handle, 0x000014C0);
            res = midiOutShortMsg(handle, 0x00103C90);
            res = midiOutShortMsg(handle, 0x00104090);
            res = midiOutShortMsg(handle, 0x00104390);

            //Thread.Sleep(3000);
            //res = midiOutClose(handle);
        }

        void CallBack(int handle, int message, int instance, int param1, int param2)
        {
            MessageBox.Show(message.ToString());
            //var res = midiOutClose(handle);
            //var res = midiOutShortMsg(handle, 0x007F3C80);
        }
    }
}
