﻿using System.Runtime.InteropServices;

namespace midi
{
    public abstract class PlayerBase
    {
        [DllImport("winmm.dll")]
        protected static extern int midiOutOpen(ref int handle,
int deviceID, MidiCallBack proc, int instance, int flags);

        [DllImport("winmm.dll")]
        protected static extern int midiOutShortMsg(int handle,
           int message);

        [DllImport("winmm.dll")]
        protected static extern int midiOutClose(int handle);

        protected delegate void MidiCallBack(int handle, int msg,
   int instance, int param1, int param2);


        protected int handle = 0;

        public int[] MsgList { get; set; }

        public void Open()
        {
            midiOutOpen(ref handle, 0, null, 0, 0);
        }

        public void Close()
        {
            midiOutClose(handle);
            handle = 0;
        }

        public abstract void Play();

    }
}
