﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace midi
{
    [DisplayName("Тестер аккордов"), Description("Форма для тестирования парсера аккордов. "+
        "Аккорд записывается в текстовое поле для аккорда, а с помощью шаблона, " +
        "вставляемого во второе поле можно проиграть звуки аккорда.")]
    public partial class TestChordParserForm : Form
    {
        public TestChordParserForm()
        {
            InitializeComponent();
        }

        private void btnPlay_Click(object sender, EventArgs e)
        {
            var msgs = new int[] {25 << 8 | 0xc0 }.Concat( ChordMaster.CreateChordFromTemplate(this.tbTemplate.Text, ChordMaster.ParseChord(this.tbChord.Text).Select(i => i + (int)nudOctave.Value*12).ToArray(), 3000, 127, 1)).ToArray();
            var player = new MelodyPlayer() { MsgList = msgs };
            player.Open();
            player.Play();
            player.Close();
        }
    }
}
