﻿using System.Collections.Generic;
using System.Threading;
namespace midi
{
    class TimerPlayer : PlayerBase
    {

        private Queue<MessagesPackage> pkgqueue;
        private Timer timer;


        public int TimeLine { get; set; }
        public int TimerInterval { get; set; } = 50;
        private void TimerTick(object state)
        {
            if (pkgqueue.Peek() == null)
            {
                timer.Dispose();
                TimeLine = 0;
                Close();
                return;
            }
            while (pkgqueue.Peek().TimeLine <= TimeLine)
            {
                pkgqueue.Dequeue().MessagesList.ForEach(msg => midiOutShortMsg(handle, msg));
            }
            TimeLine += TimerInterval;
        }



        private void CreatePackageQueue()
        {
            var msglist = MessageProcessor.GetPackagesList(this.MsgList);
            pkgqueue = new Queue<midi.MessagesPackage>(msglist);
        }


        public void Pause()
        {
            timer.Dispose();
            pkgqueue = null;
            Close();
        }

        public void GoOn()
        {
            CreatePackageQueue();
            timer = new Timer(TimerTick, null, 0, TimerInterval);
        }

        public override void Play()
        {
            TimeLine = 0;
            GoOn();
        }
    }
}
